'''
 * Copyright: STEM Loyola
 * Date     : August 2019
 * ID       : 19.08-B1
 * Level    : 1 (Amateur)
 *
 * Task     : Your form two friend, Ali, is currently learning how to solve
 *            quadratic equations. Ali knows that you are learning programming
 *            and has asked you to create a program that he can use to check if
 *            his answers are correct. Both you and Ali know that a quadratic
 *            equation is of the form: a^2 + bx + c = 0 and the value of "a"
 *            cannot be zero. Ali needs the program to input the three numbers
 *            (a, b and c) and produce the solution to the equation i.e. the
 *            value(s) of x that makes the equation zero.
 *
 *            In general, the two values of x that solve the equation can be
 *            computed as shown in Figure 1.
 *
 *            Note: (1) When b^2 < 4ac, the equation does not have real
 *                      solutions and your program should just say
 *                      "No Real Solutions".
 *                  (2) If a = 0, your program should just say
 *                      "The value of 'a' cannot be zero".

 *
 * Solved By: STEM Loyola Team
 *     Email: stemloyola@gmail.com
 *     Form : N/A
 *    Stream: N/A
'''

from math import sqrt

# Ask the user for the values of coefficients
print("Quadratic equation: a^2 + bx + c = 0 and 'a' is not zero")

a = float(input("Enter value of \"a\": "))
b = float(input("Enter value of \"b\": "))
c = float(input("Enter value of \"c\": "))

INFINITESIMAL = 0.000001   # Assume any value less than this is zero

# Try to calculate the roots of the equation
if abs(a) < INFINITESIMAL:
    # Note: Due to the way computers store decimal values, it is not ideal
    #       to compare two decimal point values using the equal sign (=).
    #       For further reading, refer to
    #       https://docs.python.org/2/tutorial/floatingpoint.html
    print("The value of 'a' cannot be zero")
else:
    discriminant = b * b - 4 * a * c
    
    if discriminant < 0:  # Square root of a negative number is not real
        print("No Real Solutions")
    else:
        x1 = (-b + sqrt(discriminant)) / (2 * a)
        x2 = (-b - sqrt(discriminant)) / (2 * a)
        
        print("Roots are ", x1, " and ", x2)


